<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>marvelous</groupId>
    <artifactId>main-project</artifactId>
    <version>1.0-SNAPSHOT</version>
    <packaging>jar</packaging>
    <name>MainProject</name>

    <properties>
        <gitlabProjectId>23004678</gitlabProjectId>
        <mainClass>marvelous.Main</mainClass>

        <!-- dependencies -->
        <gitLabDependencyProjectIdFourtyTwo>22991509</gitLabDependencyProjectIdFourtyTwo>
        <gitLabDependencyProjectIdMagicNumber>23007033</gitLabDependencyProjectIdMagicNumber>
    </properties>


    <repositories>
        <!-- used to deploy artifact to the project registry -->
        <repository>
            <id>gitlab-maven</id>
            <url>https://gitlab.com/api/v4/projects/${gitlabProjectId}/packages/maven</url>
        </repository>
        
        <!-- dependencies -->
        <repository>
            <id>gitlab-maven-dependency-fourty-two</id>
            <url>https://gitlab.com/api/v4/projects/${gitLabDependencyProjectIdFourtyTwo}/packages/maven</url>
        </repository>

        <repository>
            <id>gitlab-maven-dependency-magic-number</id>
            <url>https://gitlab.com/api/v4/projects/${gitLabDependencyProjectIdMagicNumber}/packages/maven</url>
        </repository>
        
    </repositories>

    <dependencies>
        <dependency>
            <groupId>acme</groupId>
            <artifactId>fourty-two</artifactId>
            <version>1.0-SNAPSHOT</version>
        </dependency>

        <dependency>
            <groupId>wonderland</groupId>
            <artifactId>magic-number</artifactId>
            <version>1.0-SNAPSHOT</version>
        </dependency>
    </dependencies>   

    <!-- used to deploy artifact to the project registry -->
    <distributionManagement>
        <repository>
            <id>gitlab-maven</id>
            <url>https://gitlab.com/api/v4/projects/${gitlabProjectId}/packages/maven</url>
        </repository>
        <snapshotRepository>
            <id>gitlab-maven</id>
            <url>https://gitlab.com/api/v4/projects/${gitlabProjectId}/packages/maven</url>
        </snapshotRepository>
    </distributionManagement>

    <build>
        <sourceDirectory>src</sourceDirectory>
        <!--<testSourceDirectory>test</testSourceDirectory>-->
        <resources>
            <resource>
                <directory>src</directory>
                <excludes>
                    <exclude>**/*.java</exclude>
                </excludes>
            </resource>
        </resources>

        <plugins>

            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-compiler-plugin</artifactId>
                <version>3.0</version>
                <configuration>
                    <source>1.8</source>
                    <target>1.8</target>
                </configuration>
            </plugin>

            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-assembly-plugin</artifactId>
                <version>2.2.2</version>
                <configuration>
                    <descriptorRefs>
                        <descriptorRef>jar-with-dependencies</descriptorRef>
                    </descriptorRefs>
                    <archive>
                        <manifest>
                            <mainClass>${mainClass}</mainClass>
                        </manifest>
                    </archive>
                    <appendAssemblyId>false</appendAssemblyId>
                    <!--
                    <outputDirectory>jars</outputDirectory>
                    -->
                    <finalName>main-project.${project.version}</finalName>
                </configuration>
            </plugin>

        </plugins>
    </build>

</project>
